/*->c.utils */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "bbc.h"


#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "crc.h"
#include "xext.h"


#include "constants.h"


#include "utils.h"




os_error * sxbeep(int type,int freq,int duration)
{
 int claim;

 claim=0;

 event(EVENT_BEEP,&claim,type);
 if(!claim) bbc_beep(freq,duration);
 return(NULL);
}


void beep(int fp)
{
 zreport(sxbeep(stack[fp],stack[fp+1],stack[fp+2]));
}


void keypress(int fp)
{
 zreport(fx(138,0,stack[fp]));
}



// this is not doing anything, it used to look at the font prefix path
// need to consider two situations, do something to force a change in fonts
// don't know if this is possible on Win.
// second external event
// disable the first by tweeking checkforchange below


static int fontcrc;


static int getfontcrc(void)
{
 return(!fontcrc);
}



static os_error * fontschanged(wimp_msgstr * msg,int * ack)
{
 int    changed;
 int    newcrc;

 changed=0;

 newcrc=getfontcrc();
 changed=(newcrc!=fontcrc);

 if(changed)
 {
  fontcrc=newcrc;
  event(EVENT_FONTSCHANGED,NULL,0);
 }

 return(NULL);
 USE(msg);
 USE(ack);
}



os_error * forcefontschangelo(void)
{
	fontcrc=!fontcrc;
	return(fontschanged(NULL,NULL));
}



os_error * checkforfontschange(void)
{
 // return(fontschanged(NULL,NULL));
 return(NULL);
}



os_error * utilsinit(void)
{
 os_error * err;

 err=addmessage(fontschanged,wimp_MFONTCHANGE);
// if(!err) err=addmessage(fontschanged,wimp_MMODECHANGE); // not ever going to see this
 if(!err) fontcrc=getfontcrc();

 return(err);
}


