/*->c.xlink */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "font.h"
#include "transform.h"


#include "wos.h"
#include "err.h"

#include "poll.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "task.h"
#include "csv.h"
#include "save.h"
#include "appreg.h"


#include "str.h"

#include "mhi.h"
#include "obj.h"
#include "object.h"

#include "main.h"

#include "view.h"
#include "file.h"

#include "txstr.h"
#include "tx.h"
#include "fox.h"
#include "styleif.h"
#include "merge.h"

#include "line.h"


#include "new.h"
#include "dbnew.h"
#include "dbfile.h"
#include "dbpage.h"
#include "dbgrid.h"
#include "dbscale.h"
#include "dbpicture.h"
#include "dbpixinfo.h"
#include "pxstr.h"
#include "dbpixref.h"
#include "dbcolumn.h"
#include "dbfind.h"
#include "dbflow.h"
#include "dbline.h"
#include "dbstyle.h"
#include "dbul.h"
#include "dbdup.h"
#include "dbtext.h"
#include "rulers.h"
#include "tools.h"
#include "buttons.h"
#include "infopal.h"
#include "objectdb.h"
#include "selaction.h"
#include "select.h"
#include "undo.h"
#include "spell.h"
#include "dbsp.h"
#include "dbsped.h"
#include "spchk.h"
#include "roman.h"
#include "dbprint.h"
#include "dbpref.h"
#include "clip.h"
#include "group.h"
#include "macros.h"
#include "trap.h"
#include "dbmacros.h"
#include "choices.h"
#include "txchoices.h"
#include "dbmore.h"
#include "pxchoices.h"
#include "caret.h"
#include "dbchars.h"
#include "dbspchk.h"
#include "dbborder.h"
#include "dbcolour.h"
#include "xxcolour.h"
#include "dbedcol.h"
#include "dbchart.h"
#include "units.h"
#include "xprint.h"
#include "dbmodchap.h"
#include "scripts.h"
#include "bms.h"
#include "ole.h"
#include "swind.h"
#include "xpage.h"
#include "pref.h"
#include "xredraw.h"
#include "curve.h"
#include "tag.h"
#include "dscript.h"
#include "dbfields.h"
#include "xsect.h"
#include "toolbox.h"
#include "gpbox.h"
#include "textimport.h"
#include "transload.h"
#include "appletman.h"
#include "dbfontman.h"
#include "fontmenu.h"
#include "utils.h"
#include "pxcache.h"

#include "xprocess.h"
#include "impex.h"
#include "pict.h"
#include "imlib.h"
#include "prstr.h"
#include "postscript.h"
#include "psppd.h"
#include "act.h"


#include "test.h"



#include "xext.h"

#include "xlink.h"


#define REGVERSION 0



static void xxx_test(int fp)
{
#ifdef _DEBUG

 char * key;

 key=appregmakekey(stringptr(stack[fp]),REGVERSION,stack[fp+2]?APPREGOPSLCODE:APPREGOPCODE,stack[fp+1]);

 assignstring(stack[fp],key);

#endif
}





#define XFNS 512


static fndefn fntable[XFNS]=
{
 "addentry_menu",(extfn)addentry_menu,"IRRRRR",PINT,6,
 "addentryl_menu",(extfn)addentryl_menu,"IRRRRR",PINT,6,
 "canredo",(extfn)canredo,NULL,PINT,0,
 "canundo",(extfn)canundo,NULL,PINT,0,
 "clearselection",(extfn)xclearselection,NULL,PVOID,0,
 "content_menu",(extfn)content_menu,"I",PINT,1,
 "content_name",(extfn)content_name,NULL,PSTR,0,
 "copyselection",(extfn)xcopyselection,NULL,PVOID,0,
 "create_menu",(extfn)create_menu,"R",PINT,1,
 "delete_menu",(extfn)delete_menu,"I",PVOID,1,
 "deleteselection",(extfn)xdeleteselection,NULL,PVOID,0,
 "openeditcolourbox",(extfn)editcolour,"I",PVOID,1,
 "getalign",(extfn)getalign,NULL,PINT,0,
 "getbuttons",(extfn)getbuttons,NULL,PINT,0,
 "getcase",(extfn)getcase,NULL,PINT,0,
 "getfacingpages",(extfn)getdouble,NULL,PINT,0,
 "getfont",(extfn)getfont,NULL,PINT,0,
 "getsubfont",(extfn)getsubfont,NULL,PINT,0,
 "getfontname",(extfn)getfontname,"IR",PINT,2,
 "getfontsubname",(extfn)getfontsubname,"IIIR",PINT,4,
 "getfontsize",(extfn)getfontsize,NULL,PINT,0,
 "getgrid",(extfn)getgrid,NULL,PINT,0,
 "getbasegrid",(extfn)getbasegrid,NULL,PINT,0,
 "getguides",(extfn)getguides,NULL,PINT,0,
 "getinfopal",(extfn)getinfopal,NULL,PINT,0,
 "getlinewidth",(extfn)getlinewidth,NULL,PINT,0,
 "getlinecaps",(extfn)getlinecaps,"I",PINT,1,
 "getlinepattern",(extfn)getlinestyle,NULL,PINT,0,
 "getlinejoin",(extfn)getlinejoin,NULL,PINT,0,
 "getlinewindingrule",(extfn)getlinewindingrule,NULL,PINT,0,
 "getlinetriangle",(extfn)getlinetriangle,"II",PINT,2,
 "getvalign",(extfn)getvalign,NULL,PINT,0,
 "getfirstline",(extfn)getfirstline,NULL,PINT,0,
 "getguidewidth",(extfn)getguidewidth,NULL,PINT,0,
 "getmargins",(extfn)getmargins,NULL,PINT,0,
 "getnewpagesize",(extfn)getnewpagesize,"I",PINT,1,
 "getunits",(extfn)getunits,NULL,PINT,0,
 "getpictures",(extfn)getpictures,NULL,PINT,0,
 "getrulers",(extfn)getrulers,NULL,PINT,0,
 "getsnapstate",(extfn)getsnapstate,NULL,PINT,0,
 "gettint",(extfn)gettint,NULL,PINT,0,
 "gettools",(extfn)gettools,NULL,PINT,0,
 "grid_box",(extfn)grid_box,"I",PINT,1,
 "info_box",(extfn)info_box,"I",PINT,1,
 "string_menu",(extfn)menustring,"II",PSTR,2,
 "newview",(extfn)newview,"I",PVOID,1,
 "opendelpagebox",(extfn)opendelpagebox,NULL,PVOID,0,
 "openduplicatebox",(extfn)openduplicatebox,NULL,PVOID,0,
 "openfindbox",(extfn)openfind,NULL,PVOID,0,
 "openinspagebox",(extfn)openinspagebox,NULL,PVOID,0,
 "opennewbox",(extfn)opennewbox,NULL,PVOID,0,
 "openobjectbox",(extfn)openobjectbox,NULL,PVOID,0,
 "openpageguidebox",(extfn)openpagebox,NULL,PVOID,0,
 "openstylebox",(extfn)openstylebox,"I",PVOID,1,
 "opentextflowbox",(extfn)opentextflowbox,NULL,PVOID,0,
 "rementry_menu",(extfn)rementry_menu,"II",PVOID,2,
 "redo",(extfn)redo,NULL,PVOID,0,
 "savedocument_box",(extfn)savedocument_box,"I",PINT,1,
 "zoom_box",(extfn)scale_box,"I",PINT,1,
 "selectall",(extfn)xselectall,NULL,PVOID,0,
 "setalign",(extfn)setalign,"I",PVOID,1,
 "setbuttons",(extfn)setbuttons,"I",PVOID,1,
 "setcase",(extfn)setcase,"I",PVOID,1,
 "setfacingpages",(extfn)setdouble,"I",PVOID,1,
 "setfont",(extfn)setfont,"I",PVOID,1,
 "setsubfont",(extfn)setsubfont,"II",PVOID,2,
 "setfontsize",(extfn)setfontsize,"I",PVOID,1,
 "setgrid",(extfn)setgrid,"I",PVOID,1,
 "setbasegrid",(extfn)setbasegrid,"I",PVOID,1,
 "setguides",(extfn)setguides,"I",PVOID,1,
 "setinfopal",(extfn)setinfopal,"I",PVOID,1,
 "setlinecaps",(extfn)setlinecaps,"II",PVOID,2,
 "setlinewidth",(extfn)setlinewidth,"I",PVOID,1,
 "setlinejoin",(extfn)setlinejoin,"I",PVOID,1,
 "setlinepattern",(extfn)setlinestyle,"II",PVOID,2,
 "setlinewindingrule",(extfn)setlinewindingrule,"I",PVOID,1,
 "setlinetriangle",(extfn)setlinetriangle,"III",PVOID,3,
 "setvalign",(extfn)setvalign,"I",PVOID,1,
 "setfirstline",(extfn)setfirstline,"I",PVOID,1,
 "setguidewidth",(extfn)setguidewidth,"I",PVOID,1,
 "setmargins",(extfn)setmargins,"I",PVOID,1,
 "setnewpagesize",(extfn)setnewpagesize,"IIRI",PVOID,4,
 "setunits",(extfn)setunits,"I",PVOID,1,
 "setpictures",(extfn)setpictures,"I",PVOID,1,
 "setrulers",(extfn)setrulers,"I",PVOID,1,
 "setsnapstate",(extfn)setsnapstate,"I",PVOID,1,
 "settint",(extfn)settint,"I",PVOID,1,
 "settools",(extfn)settools,"I",PVOID,1,
 "stringu",(extfn)stringu,"RI",PINT,2,
 "stringdp",(extfn)stringdp,"R",PINT,1,
 "quit",(extfn)xterminate,NULL,PVOID,0,
 "undo",(extfn)undo,NULL,PVOID,0,
 "ustring",(extfn)ustring,"II",PSTR,2,
 "dpstring",(extfn)dpstring,"II",PSTR,2,
 "groupselection",(extfn)groupselection,NULL,PVOID,0,
 "ungroupselection",(extfn)ungroupselection,NULL,PVOID,0,
 "canungroup",(extfn)canungroup,NULL,PINT,0,
 "cangroup",(extfn)cangroup,NULL,PINT,0,
 "cangofront",(extfn)cangoforward,NULL,PINT,0,
 "cangoback",(extfn)cangobackward,NULL,PINT,0,
 "objectfront",(extfn)objectforward,NULL,PVOID,0,
 "objectback",(extfn)objectbackward,NULL,PVOID,0,
 "undostring",(extfn)undostring,NULL,PSTR,0,
 "redostring",(extfn)redostring,NULL,PSTR,0,
 "opencolourbox",(extfn)opentextcolour,NULL,PVOID,0,
 "openformatbox",(extfn)opentextformat,NULL,PVOID,0,
 "opentabsbox",(extfn)opentexttabs,NULL,PVOID,0,
 "openrulesbox",(extfn)opentextrules,NULL,PVOID,0,
 "geteffect",(extfn)geteffx,NULL,PINT,0,
 "seteffect",(extfn)seteffx,"I",PVOID,1,
 "addstyle",(extfn)addstyle,"I",PVOID,1,
 "remstyle",(extfn)remstyle,"I",PVOID,1,
 "iscurrentstyle",(extfn)iscurrentstyle,"I",PINT,1,
 "cleareffects",(extfn)cleareffects,"I",PVOID,1,
 "getuserstyle",(extfn)getuserstyle,"IRI",PINT,3,
 "getcurrentstyle",(extfn)getcurrentstyle,"IRI",PINT,3,
 "getscope",(extfn)getscope,NULL,PINT,0,
 "setscope",(extfn)setscope,"I",PVOID,1,
 "getrulewidth",(extfn)getrulewidth,NULL,PINT,0,
 "setrulewidth",(extfn)setrulewidth,"I",PVOID,1,
 "setleading",(extfn)readleading,"R",PVOID,1,
 "getleading",(extfn)writeleading,"R",PVOID,1,
 "view_box",(extfn)view_box,"I",PINT,1,
 "pasteselection",(extfn)xpasteselection,NULL,PVOID,0,
 "cutselection",(extfn)xcutselection,NULL,PVOID,0,
 "opengotopagebox",(extfn)opengotopagebox,NULL,PVOID,0,
 "deletechapter",(extfn)deletechapter,NULL,PVOID,0,
 "opendictionarybox",(extfn)dictionarybox,NULL,PVOID,0,
 "checkstory",(extfn)checkstory,"I",PVOID,1,
 "checkword",(extfn)checkword,NULL,PVOID,0,
 "checkdocument",(extfn)checkdocument,NULL,PVOID,0,
 "getcheck",(extfn)getcheck,NULL,PINT,0,
 "setcheck",(extfn)setcheck,"I",PVOID,1,
 "openprintbox",(extfn)printbox,NULL,PVOID,0,
 "reverttosaved",(extfn)reverttosaved,NULL,PVOID,0,
 "fontschanged",(extfn)fontschanged,NULL,PINT,0,
 "openprefbox",(extfn)openprefbox,NULL,PVOID,0,
 "makeselectionlocal",(extfn)makeselectionlocal,NULL,PVOID,0,
 "makeselectionmaster",(extfn)makeselectionmaster,NULL,PVOID,0,
 "canmakelocal",(extfn)canmakelocal,NULL,PINT,0,
 "canmakemaster",(extfn)canmakemaster,NULL,PINT,0,
 "getclipboard",(extfn)getclipboard,NULL,PINT,0,
 "setclipboard",(extfn)setclipboard,"I",PVOID,1,
 "savestylesheet_box",(extfn)savestylesheet_box,"I",PINT,1,
 "export_box",(extfn)export_box,"I",PINT,1,
 "export_name",(extfn)export_name,"R",PINT,1,
 "fileinfo_box",(extfn)fileinfo_box,"I",PINT,1,
 "openmacrobox",(extfn)openmacros,NULL,PVOID,0,
 "delallmacros",(extfn)delallmacros,NULL,PVOID,0,
 "delmacro",(extfn)delmacro,"R",PVOID,1,
 "defmacro",(extfn)defmacro,"IRRR",PVOID,4,
 "defmacro2",(extfn)defmacro2,"IRRRR",PVOID,5,
 "isdefmacro",(extfn)isdefmacro,"R",PINT,1,
 "open_menu",(extfn)openmenuhandle,"I",PVOID,1,
 "savedocument",(extfn)savedocument,"R",PVOID,1,
 "savedocumentastype",(extfn)savedocumentastype,"RI",PVOID,2,
 "openchoicesbox",(extfn)openchoicesbox,NULL,PVOID,0,
 "generalchoices",(extfn)generalchoices,"RRII",PVOID,4,
 "generalchoices2",(extfn)generalchoices2,"IIII",PVOID,4,
 "readgeneralchoices2",(extfn)readgeneralchoices2,"I",PINT,1,
 "viewchoices1",(extfn)viewchoices1,"IIIII",PVOID,5,
 "viewchoices2",(extfn)viewchoices2,"IIIIII",PVOID,6,
 "viewchoices3",(extfn)viewchoices3,"IIII",PVOID,4,
 "textchoices",(extfn)textchoices,"RIIIIIIII",PVOID,9,
 "textchoices2",(extfn)textchoices2,"IIII",PVOID,4,
 "textchoicesbits",(extfn)textchoicesbits,NULL,PINT,0,
 "undochoices",(extfn)undochoices,"II",PVOID,2,
 "picturechoices",(extfn)picturechoices,"IIIIII",PVOID,6,
 "picturechoices2",(extfn)picturechoices2,"IIIII",PVOID,5,
 "picturechoices3",(extfn)picturechoices3,"IIII",PVOID,4,
 "embedobject",(extfn)embedobject,NULL,PVOID,0,
 "snaptogrid",(extfn)snaptogrid,NULL,PVOID,0,
 "openshapebox",(extfn)openshapebox,NULL,PVOID,0,
 "type",(extfn)type,"R",PVOID,1,
 "timestring",(extfn)timestring,NULL,PSTR,0,
 "datestring",(extfn)xdatestring,NULL,PSTR,0,
 "linechoices",(extfn)linechoices,"III",PVOID,3,
 "selection_name",(extfn)selection_name,NULL,PSTR,0,
 "paste_name",(extfn)paste_name,NULL,PSTR,0,
 "openobjectcontentsbox",(extfn)openobjectcontentsbox,NULL,PVOID,0,
 "opencharsbox",(extfn)openchars,NULL,PVOID,0,
 "getnumberformat",(extfn)getbulletformat,NULL,PINT,0,
 "setnumberformat",(extfn)setbulletformat,"I",PVOID,1,
 "setuserstyle",(extfn)setuserstyle,"I",PVOID,1,
 "isuserstyle",(extfn)isuserstyle,"I",PINT,1,
 "openmergebox",(extfn)openmergebox,NULL,PVOID,0,
 "getuserdict",(extfn)getuserdict,"IR",PINT,2,
 "setuserdict",(extfn)setuserdict,"I",PVOID,1,
 "isuserdict",(extfn)isuserdict,"I",PINT,1,
 "openborderbox",(extfn)openborderbox,NULL,PVOID,0,
 "viewpref1",(extfn)viewpref1,"IIIIIII",PVOID,7,
 "generalpref",(extfn)generalpref,"IIIIII",PVOID,6,
 "generalpref2",(extfn)generalpref2,"IIII",PVOID,4,
 "textpref",(extfn)textpref,"IIIIII",PVOID,6,
 "textpref2",(extfn)textpref2,"RRRR",PVOID,4,
 "setulwidth",(extfn)readulwidth,"R",PVOID,1,
 "getulwidth",(extfn)writeulwidth,"R",PVOID,1,
 "getcolourpal",(extfn)getcolourpal,"IIII",PINT,4,
 "getcolour",(extfn)xgetcolour,"IRI",PINT,3,
 "setcolour",(extfn)setcolour,"I",PVOID,1,
 "getcolourchart",(extfn)getcolourchart,"IR",PINT,2,
 "setcolourchart",(extfn)setcolourchart,"I",PVOID,1,
 "iscurrentchart",(extfn)iscurrentchart,"I",PINT,1,
 "setzoom",(extfn)setzoom,"III",PVOID,3,
 "getgridlock",(extfn)getgridlock,NULL,PINT,0,
 "setgridlock",(extfn)setgridlock,"I",PVOID,1,
 "getinvisibles",(extfn)getinvisibles,NULL,PINT,0,
 "setinvisibles",(extfn)setinvisibles,"I",PVOID,1,
 "getpasteboard",(extfn)getpasteboard,NULL,PINT,0,
 "setpasteboard",(extfn)setpasteboard,"I",PVOID,1,
 "curpageno",(extfn)curpageno,NULL,PINT,0,
 "curchapterno",(extfn)cursectionno,NULL,PINT,0,
 "caretchar",(extfn)caretchar,NULL,PINT,0,
 "prevchar",(extfn)prevchar,NULL,PINT,0,
 "activetype",(extfn)activetype,"I",PINT,1,
 "saveasdefault",(extfn)saveasdefault,NULL,PVOID,0,
 "caretcontext",(extfn)caretcontext,NULL,PVOID,0,
 "setmaindictionary",(extfn)setmaindictionary,"R",PVOID,1,
 "setuserdictionary",(extfn)setuserdictionary,"R",PVOID,1,
 "getlinescale",(extfn)getlinescale,NULL,PINT,0,
 "duplicateselection",(extfn)xduplicateselection,"III",PVOID,3,
 "printchoices",(extfn)printchoices,"IIII",PVOID,4,
 "printchoices2",(extfn)printchoices2,"IIII",PVOID,4,
 "printchoices3",(extfn)printchoices3,"IIII",PVOID,4,
 "printchoices4",(extfn)printchoices4,"IIIII",PVOID,5,
 "getprintbits",(extfn)xgetprintbits,NULL,PINT,0,
 "ismasterview",(extfn)ismasterview,NULL,PINT,0,
 "opennewchapterbox",(extfn)newchapterbox,"I",PVOID,1,
 "openmodchapterbox",(extfn)modchapterbox,NULL,PVOID,0,
 "issaved",(extfn)issaved,NULL,PINT,0,
 "ischanged",(extfn)ischanged,NULL,PINT,0,
 "cliptype",(extfn)cliptype,NULL,PINT,0,
 "nselected",(extfn)xnselected,NULL,PINT,0,
 "openprintmergebox",(extfn)printmergebox,NULL,PVOID,0,
 "setprintmode",(extfn)setprintmode,"I",PVOID,1,
 "getprintmode",(extfn)getprintmode,NULL,PINT,0,
 "cancopy",(extfn)cancopy,NULL,PINT,0,
 "canmodify",(extfn)canmodify,NULL,PINT,0,
 "candelete",(extfn)candelete,NULL,PINT,0,
 "canshape",(extfn)canshape,NULL,PINT,0,
 "flushundobuffer",(extfn)flushundobuffer,NULL,PINT,0,
 "picktool",(extfn)picktool,"II",PVOID,2,
 "canduplicate",(extfn)canduplicate,NULL,PINT,0,
 "toolchoices",(extfn)toolchoices,"IIII",PVOID,4,
 "toolrank",(extfn)toolrank,"IIII",PVOID,4,
 "objectforward",(extfn)objectforwardn,"I",PVOID,1,
 "objectbackward",(extfn)objectbackwardn,"I",PVOID,1,
 "impexbits",(extfn)impexbits,"III",PINT,3,
 "impexcopy",(extfn)impexcopy,"IIR",PINT,3,
/* "settrap",(extfn)settrap,"IIRR",PVOID,4, */
 "addeventhandler",(extfn)addeventhandler,"IIR",PVOID,3,
 "remeventhandler",(extfn)remeventhandler,"IIR",PVOID,3,
 "filefromview",(extfn)filefromview,"I",PINT,1,
 "currentview",(extfn)currentview,NULL,PINT,0,
 "currentfile",(extfn)currentfile,NULL,PINT,0,
 "fileinfo",(extfn)fileinfo,"IR",PINT,2,

 "bmcreate",(extfn)bmcreate,"R",PINT,1,
 "bmdelete",(extfn)bmdelete,"I",PVOID,1,
 "bmfind",(extfn)bmfind,"R",PINT,1,
 "setbmtocaret",(extfn)setbmtocaret,"I",PVOID,1,
 "setcarettobm",(extfn)setcarettobm,"I",PVOID,1,
 "setzonetobm",(extfn)setzonetobm,"I",PVOID,1,
 "bmview",(extfn)bmview,"I",PVOID,1,
 "bmchar",(extfn)bmchar,"I",PINT,1,
 "bmprevchar",(extfn)bmprevchar,"I",PINT,1,
 "setbmtobm",(extfn)setbmtobm,"II",PVOID,2,
 "bmmove",(extfn)bmmove,"III",PINT,3,
 "bmname",(extfn)bmname,"IR",PINT,2,
 "setbmtozone",(extfn)setbmtozone,"II",PVOID,2,
 "bmcmp",(extfn)bmcmp,"II",PINT,2,

 "bmsearch",(extfn)bmsearch,"IIRI",PINT,4,
 "replace",(extfn)replace,"RI",PINT,2,
 "bmstartscan",(extfn)bmstartscan,NULL,PVOID,0,
 "bmnextstory",(extfn)bmnextstory,"I",PINT,1,

 "olesetup",(extfn)olesetup,"IIII",PVOID,4,
 "zoneorder",(extfn)zoneorder,NULL,PINT,0,

 "menudefstring",(extfn)menudefstring,"IIIR",PINT,4,
 "insertentry_menu",(extfn)insertentry_menu,"IIRRRRR",PINT,7,
 "menuprevious",(extfn)menuprevious,"I",PINT,1,

 "getbaseshift",(extfn)getbaseshift,NULL,PINT,0,
 "setbaseshift",(extfn)setbaseshift,"I",PVOID,1,

 "printdocument",(extfn)xprintdoc,NULL,PVOID,0,

 "create_window",(extfn)create_window,"R",PINT,1,
 "delete_window",(extfn)delete_window,"I",PVOID,1,
 "display_window",(extfn)display_window,"III",PVOID,3,
 "open_window",(extfn)open_window,"IIIIIIII",PVOID,8,
 "close_window",(extfn)close_window,"I",PVOID,1,
 "writeicon",(extfn)swriteicon,"IIR",PVOID,3,
 "readicon",(extfn)sreadicon,"II",PSTR,2,
 "addwindowhandler",(extfn)addwindowhandler,"IIR",PVOID,3,

 "create_menuwindow",(extfn)create_menuwindow,"II",PINT,2,
 "delete_menuwindow",(extfn)delete_menuwindow,"I",PVOID,1,

 "pixsetup",(extfn)pixsetup,"IIII",PVOID,4,
 "fontsetup",(extfn)fontsetup,"IIII",PVOID,4,


 "documentchapters",(extfn)documentchapters,"I",PINT,1,
 "chapterpages",(extfn)chapterpages,"II",PINT,2,
 "chapterstart",(extfn)chapterstart,"I",PINT,1,
 "pagestart",(extfn)pagestart,"II",PINT,2,
 "selectionpage",(extfn)selectionpage,NULL,PINT,0,
 "selectionchapter",(extfn)selectionchapter,NULL,PINT,0,
 "selectionfile",(extfn)selectionfile,NULL,PINT,0,
 "currentpage",(extfn)currentpage,"I",PINT,1,
 "currentchapter",(extfn)currentchapter,"I",PINT,1,
 "gotopage",(extfn)xgotopage,"III",PVOID,3,
 "chapterbits",(extfn)chapterbits,"II",PINT,2,

 "bmpage",(extfn)bmpage,"I",PINT,1,
 "bmsection",(extfn)bmsection,"I",PINT,1,
 "bmchapter",(extfn)bmsection,"I",PINT,1,

 "extent_window",(extfn)extent_window,"IIIII",PVOID,5,
 "delete_icon",(extfn)delete_icon,"II",PVOID,2,
 "select_icon",(extfn)select_icon,"III",PVOID,3,
 "insert_caret",(extfn)insert_caret,"II",PVOID,2,
 "create_icon",(extfn)create_icon,"IIIIIIRRI",PINT,9,
 "plot_icon",(extfn)plot_icon,"IIIIIIRR",PVOID,8,
 "refresh_area",(extfn)refresh_area,"IIIIII",PVOID,6,
 "refresh_icon",(extfn)refresh_icon,"III",PVOID,3,
 "set_icon_state",(extfn)set_icon_state,"IIII",PVOID,4,
 "getstylescope",(extfn)getstylescope,"I",PINT,1,
 
 "setcurrentview",(extfn)setcurrentview,"I",PINT,1,
 "setcurrentfile",(extfn)setcurrentfile,"I",PINT,1,

 "islocaleffect",(extfn)islocaleffect,NULL,PINT,0,
 "nextfile",(extfn)nextfile,"I",PINT,1,
 "nextuserfile",(extfn)nextuserfile,"I",PINT,1,
 "nextview",(extfn)nextview,"II",PINT,2,
 "password",(extfn)password,"RRII",PINT,4,

 "filescrap",(extfn)filescrap,"I",PVOID,1,
 "getfiletimestring",(extfn)getfiletimestring,"RRI",PVOID,3,

 "getspellerrors",(extfn)getspellerrors,NULL,PINT,0,
 "setspellerrors",(extfn)setspellerrors,"I",PVOID,1,

 "prprints",(extfn)prprints,"R",PINT,1,
 "prinfo",(extfn)prinfo,"R",PINT,1,

 "openpictureinfobox",(extfn)openpictureinfobox,NULL,PVOID,0,
 "dcsfile",(extfn)dcsfile,"I",PINT,1,
 "getclipcurve",(extfn)getclipcurve,"I",PINT,1,

 "prpagew",(extfn)prpagew,NULL,PINT,0,
 "prpageh",(extfn)prpageh,NULL,PINT,0,
 "prpagex",(extfn)prpagex,NULL,PINT,0,
 "prpagey",(extfn)prpagey,NULL,PINT,0,
 "prpageshiftx",(extfn)prpageshiftx,NULL,PINT,0,
 "prpageshifty",(extfn)prpageshifty,NULL,PINT,0,
 "prworkw",(extfn)prworkw,NULL,PINT,0,
 "prworkh",(extfn)prworkh,NULL,PINT,0,
 "prworkmaxw",(extfn)prworkmaxw,NULL,PINT,0,
 "prworkmaxh",(extfn)prworkmaxh,NULL,PINT,0,


 "programversion",(extfn)programversion,NULL,PINT,0,

 "getselectioncolour",(extfn)getselectioncolour,"II",PINT,2,
 "setselectioncolour",(extfn)setselectioncolour,"IIII",PVOID,4,
 "keyboardmode",(extfn)keyboardmode,"I",PVOID,1,

 "paperaddformat",(extfn)paperaddformat,"RIRRR",PVOID,5,
 "paperformat",(extfn)paperformat,"IR",PINT,2,
 "paperfirstpage",(extfn)paperfirstpage,NULL,PVOID,0,
 "papernextpage",(extfn)papernextpage,NULL,PINT,0,
 "paperpage",(extfn)paperpage,"IIIIIIII",PVOID,8,
 "paperpagescale",(extfn)paperpagescale,"IIIIIIIIII",PVOID,10,
 "maxpagewidth",(extfn)maxpagewidth,"I",PINT,1,
 "maxpageheight",(extfn)maxpageheight,"I",PINT,1,
 "paperpagewidth",(extfn)paperpagewidth,NULL,PINT,0,
 "paperpageheight",(extfn)paperpageheight,NULL,PINT,0,
 "paperbleed",(extfn)paperbleed,NULL,PINT,0,
 "paperarea",(extfn)paperarea,"IIIII",PVOID,5,
 "paperpagearea",(extfn)paperpagearea,"IIIIII",PVOID,6,

 "paperwidth",(extfn)paperwidth,NULL,PINT,0,
 "paperheight",(extfn)paperheight,NULL,PINT,0,
 "printerwidth",(extfn)printerwidth,NULL,PINT,0,
 "printerheight",(extfn)printerheight,NULL,PINT,0,
 "paperxscale",(extfn)paperxscale,NULL,PINT,0,
 "paperyscale",(extfn)paperyscale,NULL,PINT,0,
 "paperbits",(extfn)paperbits,NULL,PINT,0,
 "papermarks",(extfn)papermarks,NULL,PINT,0,
 "papermaxarea",(extfn)papermaxarea,"IIII",PVOID,4,
 "papermarkx",(extfn)papermarkx,"I",PINT,1,
 "papermarky",(extfn)papermarky,"I",PINT,1,
 "papercount",(extfn)papercount,"I",PINT,1,
 "prareax0",(extfn)prareax0,NULL,PINT,0,
 "prareay0",(extfn)prareay0,NULL,PINT,0,
 "prareax1",(extfn)prareax1,NULL,PINT,0,
 "prareay1",(extfn)prareay1,NULL,PINT,0,

 "tagwrite",(extfn)tagwrite,"IIII",PINT,4,
 "tagwrites",(extfn)tagwrites,"IIR",PINT,3,
 "tagexists",(extfn)tagexists,"III",PINT,3,
 "tagread",(extfn)tagread,"III",PINT,3,
 "tagreads",(extfn)tagreads,"IIR",PINT,3,

 "loadfile",(extfn)scriptloadfile,"R",PINT,1,
 "viewrepaint",(extfn)viewrepaint,"II",PVOID,2,
 "ddl",(extfn)dscode,"R",PVOID,1,
 "checkstring",(extfn)xcheckword,"IIR",PINT,3,

 "field",(extfn)mergefield,"I",PSTR,1,
 "nextrecord",(extfn)mergenextrecord,NULL,PINT,0,
 "maxfield",(extfn)mergemaxfield,NULL,PINT,0,
 "autoscroll",(extfn)autoscrollparams,"IIII",PVOID,4,
 "macro",(extfn)evalmacro,"R",PSTR,1,
 "openfields",(extfn)openfieldsx,NULL,PVOID,0,

 "openproxybox",(extfn)openproxybox,NULL,PVOID,0,
 "openpicturereferencebox",(extfn)openpicturereferencebox,NULL,PVOID,0,

 "setcurrentclipboard",(extfn)setcurrentclipboard,"I",PINT,1,
 "getcurrentclipboard",(extfn)getcurrentclipboard,NULL,PINT,0,

 "copychapter",(extfn)copychapter,NULL,PVOID,0,
 "pastechapter",(extfn)pastechapter,"I",PINT,1,

 "itors",(extfn)itors,"I",PSTR,1,
 "refreshbutton",(extfn)refreshbutton,"RII",PVOID,3,

 "getparalevel",(extfn)getparalevel,NULL,PINT,0,
 "setparalevel",(extfn)setparalevel,"I",PVOID,1,

 "getselectionx",(extfn)getselectionx,NULL,PINT,0,
 "getselectiony",(extfn)getselectiony,NULL,PINT,0,
 "getselectionw",(extfn)getselectionw,NULL,PINT,0,
 "getselectionh",(extfn)getselectionh,NULL,PINT,0,
 "setselectionarea",(extfn)setselectionarea,"IIII",PVOID,4,

 "getselectionxn",(extfn)getselectionxn,"I",PINT,1,
 "getselectionyn",(extfn)getselectionyn,"I",PINT,1,
 "getselectionwn",(extfn)getselectionwn,"I",PINT,1,
 "getselectionhn",(extfn)getselectionhn,"I",PINT,1,
 "setselectionarean",(extfn)setselectionarean,"IIIII",PVOID,5,

 "openspacebox",(extfn)openspacebox,NULL,PVOID,0,
 "writetitle",(extfn)swritetitle,"IR",PVOID,2,
 "getcaretposition",(extfn)sgetcaretposition,"I",PINT,1,
 "savetextastype",(extfn)savetextastype,"RI",PVOID,2,


// new Win functions

 "openfileinfo",(extfn)openfileinfo,NULL,PVOID,0,
 "openfilesaveas",(extfn)openfilesaveas,NULL,PVOID,0,
 "saveasstylesheet",(extfn)saveasstylesheet,NULL,PVOID,0,
 "openfileopen",(extfn)openfileopen,NULL,PVOID,0,
 "openzoombox",(extfn)openzoombox,NULL,PVOID,0,
 "openviewbox",(extfn)openviewbox,NULL,PVOID,0,
 "opengridbox",(extfn)opengridbox,NULL,PVOID,0,
 "openexportbox",(extfn)openexportbox,NULL,PVOID,0,
 "openimportbox",(extfn)openimportbox,NULL,PVOID,0,
 "openinfobox",(extfn)openinfobox,NULL,PVOID,0,
 "openappletbox",(extfn)openappletbox,NULL,PVOID,0,
 "getprintername",(extfn)getprintername,"IR",PINT,2,
 "setprintername",(extfn)setprintername,"R",PVOID,1,
 "getcurrentprinter",(extfn)getcurrentprinter,"R",PINT,1,
 "writemenustring",(extfn)writemenustring,"IIR",PVOID,3,
 "openimportwordsbox",(extfn)openimportwords,NULL,PVOID,0,
 "openexportwordsbox",(extfn)openexportwords,NULL,PVOID,0,
 "gpbox1",(extfn)gpbox1,"RRRR",PVOID,4,
 "gpbox2",(extfn)gpbox2,"RRRRRR",PVOID,6,
 "gpbox4",(extfn)gpbox4,"RRRRRRRRRR",PVOID,10,
 "transload",(extfn)transloadx,"RIRI",PINT,4,
 "helptopic",(extfn)xhelptopic,"R",PVOID,1,
 "helpwhatsthis",(extfn)xhelpwhatisthis,NULL,PVOID,0,
 "appletpath",(extfn)xappspath,"R",PVOID,1,
 "create_windowparent",(extfn)create_windowparent,"RI",PINT,2,
	"geticon",(extfn)geticon,"III",PINT,3,
 "setwindowflags",(extfn)swsetwindowflags,"III",PVOID,3,
	"viewhandle",(extfn)view_handle,"I",PINT,1,
/* "xtrans",(extfn)xtrans,NULL,PVOID,0, */
	"activeview",(extfn)xactiveview,NULL,PINT,0,
 "setactive",(extfn)swsetactivewindow,"I",PVOID,1,
 "setfocus",(extfn)swsetfocus,"I",PVOID,1,
 "setfocusicon",(extfn)swsetfocusicon,"II",PVOID,2,
 "write_slice_icon",(extfn)write_slice_icon,"IIIR",PVOID,4,
 "read_slice_icon",(extfn)read_slice_icon,"IIIR",PINT,4,

 "fontreplace",(extfn)fontreplace,"RRI",PVOID,3,
 "fontremovereplace",(extfn)fontremovereplace,"RR",PVOID,2,
 "fontclearreplace",(extfn)fontclearreplace,NULL,PVOID,0,
 "fontreplacestate",(extfn)fontreplacestate,"I",PINT,1,

 "fontpostscript",(extfn)fontpostscriptx,"RRI",PVOID,3,
 "fontremovepostscript",(extfn)fontremovepostscript,"R",PVOID,1,
 "fontclearpostscript",(extfn)fontclearpostscript,NULL,PVOID,0,
 "fontpostscriptstate",(extfn)fontpostscriptstate,"I",PINT,1,

 "fontmap",(extfn)fontmap,"RRRIRRII",PVOID,8,
 "fontremovemap",(extfn)fontremovemap,"R",PVOID,1,
 "fontclearmap",(extfn)fontclearmap,NULL,PVOID,0,
 "fontmapstate",(extfn)fontmapstate,"I",PINT,1,

 "fontignore",(extfn)fontignore,"RI",PVOID,2,
 "fontremoveignore",(extfn)fontremoveignore,"R",PVOID,1,
 "fontclearignore",(extfn)fontclearignore,NULL,PVOID,0,
 "fontignorestate",(extfn)fontignorestate,"I",PINT,1,

	"forcefontschange",(extfn)forcefontschange,NULL,PVOID,0,

 "content_menuname",(extfn)content_menuname,NULL,PSTR,0,
 "openfontman",(extfn)openfontman,NULL,PVOID,0,
	"defaultfile",(extfn)defaultfile,NULL,PINT,0,
 "opentextfont",(extfn)opentextfont,NULL,PVOID,0,

	"ps_level",(extfn)ps_level,NULL,PINT,0,
 "openregbox",(extfn)openregbox,NULL,PVOID,0,
 "shade_icon",(extfn)shade_icon,"III",PVOID,0,
 "defmacro3",(extfn)defmacro3,"IRRRRR",PVOID,6,
 "defmacro4",(extfn)defmacro4,"IRRRRRR",PVOID,7,
 "beep",(extfn)beep,"III",PVOID,3,
 "keypress",(extfn)keypress,"I",PVOID,1,
	"find_caret",(extfn)find_caret,"I",PINT,1,
 "findnext",(extfn)findnext,NULL,PVOID,0,

 "findglyphname",(extfn)xmacrofindglyphname,"I",PSTR,1,
 "findglyph",(extfn)xmacrofindglyph,"R",PINT,1,

 "viewchoices4",(extfn)viewchoices4,"IIII",PVOID,4,
 "testdoc",(extfn)xtestdoc,NULL,PVOID,0,
 "postscriptchoices0",(extfn)postscriptchoices0,"IIII",PVOID,4,

 "macrorename",(extfn)macrorename,"RR",PVOID,2,
 "macrostring",(extfn)macrostring,"RRI",PINT,3,

 "bm_hidden",(extfn)bm_hidden,"R",PINT,1,
 "bm_hide",(extfn)bm_hide,"R",PVOID,1,
 "bm_unhide",(extfn)bm_unhide,"R",PVOID,1,
 "bm_toggle",(extfn)bm_toggle,"R",PVOID,1,
 "bm_hiddenmark",(extfn)bm_hiddenmark,"R",PINT,1,


 "setcharselection",(extfn)setcharselection,"I",PVOID,1,
 "getcharselection",(extfn)getcharselection,"IR",PINT,2,
 "iscurrentcharselection",(extfn)iscurrentcharselection,"I",PINT,1,
 "viewchoices5",(extfn)viewchoices5,"IIII",PVOID,4,
 "generalpref3",(extfn)generalpref3,"IIII",PVOID,4,
 "getsmallcaps",(extfn)getsmallcaps,NULL,PINT,0,
 "setsmallcaps",(extfn)setsmallcaps,"I",PVOID,1,

	"findsetfind",(extfn)findsetfind,"I",PVOID,1,
	"findsetreplace",(extfn)findsetreplace,"I",PVOID,1,
	"findgetfind",(extfn)findgetfind,"IR",PINT,2,
	"findgetreplace",(extfn)findgetreplace,"IR",PINT,2,

 "geteffectname",(extfn)geteffectname,"IR",PVOID,2,
 "cleareffect",(extfn)cleareffect,"II",PVOID,2,
 "getnexteffect",(extfn)getnexteffect,"I",PINT,1,

	"appletdatapath",(extfn)xappsdatapath,"RR",PVOID,2,
	"pxcacheflush",(extfn)pxcacheflush,"I",PVOID,1,

 "swapcase",(extfn)swopcases,NULL,PVOID,0,
 "uppercase",(extfn)uppercases,NULL,PVOID,0,
 "lowercase",(extfn)lowercases,NULL,PVOID,0,

 "xxx_xxx",(extfn)xxx_test,"RII",PVOID,3,


 NULL,NULL,NULL,0,0
};


static xfnlink fnlink;


os_error * xset(void)
{
 os_error * err;

          err=xstart();
 if(!err) err=addsymboltable(fntable,&fnlink);
 if(!err) err=event(EVENT_SCRIPTINIT,NULL,0);

 return(err);
}

