/*->h.viewo */


#define ZOOMFIT 0
#define ZOOM50  1
#define ZOOM100 2
#define ZOOM200 3
#define ZOOMDEF 4
#define ZOOMSCR 5
#define ZOOM75  6
#define ZOOM150 7
#define ZOOM400 8
#define ZOOMSCRW 9
#define ZOOMSCRH 10


#define ZOOMMAX 1000
#define ZOOMMIN 5



extern os_error * viewmarginadjust(viewstr * view,int dleft,int dright,int dtop,int dbottom);


extern os_error * viewopen(int handle,int userhandle,wimp_openstr * o);
extern os_error * viewopenmainpane(int handle,int userhandle,wimp_openstr * o);
extern os_error * viewopenbehind(viewstr * view,filestr * file,int b);

extern int isghostleft(int left,int x);
extern int isghost(viewstr * view,int page,int section,int x);
extern int isghostb(viewstr * view,int page,int base,int x);


extern os_error * popupview(viewstr * view,filestr * file,windowstr * window,
                                                        int page,int section);

extern os_error * viewopenat(viewstr * view,filestr * file,int scx,int scy);
extern os_error * viewopenshift(viewstr * view,int dx,int dy);
extern os_error * viewopencrash(viewstr * view);

extern os_error * viewsetwindow(viewstr * view,windowstr * cwindow);


extern void setviewborders(viewstr * view);

extern int viewpageheight(viewstr * view,int page,int section,int * yshift);

extern os_error * setviewextent(viewstr * view);
extern os_error * filenewextent(filestr * file);

extern int viewprevpane(viewstr * view,filestr * file,int handle);




#define FRVREFRESH 0x1
#define FRVMST     0x2
#define FRVDOC     0x4

extern os_error * fileresetviews(filestr * file,int flags);

extern os_error * updateviewextent(viewstr * view);

extern os_error * zoomdef(viewstr * view,int xshift,int yshift);

extern os_error * zoomdef2(viewstr * view,int xshift,int yshift,
                                         int axshift,int ayshift);

extern os_error * zoomopt(viewstr * view,int opt);

extern void       zoomfitgetscr(viewstr * view,int * mul,int * div,int bits);
extern void       zoomfitget(viewstr * view,int * mul,int * div);

extern os_error * xsetdouble(viewstr * view,int newdble,int repaint);

extern os_error * viewkey(int * key);

extern os_error * gotopagek(viewstr * view,int page,int section);
extern os_error * gotopagea(viewstr * view,int pn);

extern os_error * nextscreen(int n);
extern os_error * prevscreen(int n);


