/*->h.fmapstr */



typedef struct fmaphdrstr    /* one of these for each font name */
{
 int key;
 unsigned int offset:24;              /* to font name */
 unsigned int mapped:1;
 int count;                  /* usages       */
 int ifn;                    /* unique font number, input to font cache */

} fmaphdrstr;


/* object of type FONTMAP */

typedef struct fmapbasestr
{
 int          key;
 int          type;
 chainstr     chain;
 flagstr      flags;

 int          n;              /* how many font names */

 fmaphdrstr   fmaphdr[1];

} fmapbasestr;




#define MAXFINT  0xFFFF
#define MINFINT  0x1
#define PRFINT   0x7FFF
#define BADFMAP  0x0


