/*->c.roman */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>



#include "os.h"

#include "xext.h"


#include "roman.h"




static int rvals[7]=
{
 1,5,10,50,100,500,1000
};



static int cvals[2][7]=
{
 'I','V','X','L','C','D','M',
 'i','v','x','l','c','d','m'
};



void roman(int n,int format,int branch,char ** result,int * len)
{
 static char   string[32];
 char        * s;
 int           p;
 int           i;
 int           j;


 *len=1;
 *result=string;
 s=string;


 if(branch)
 {
  string[0]='#';string[1]=0;*len=1;
 }
 else
 if(format==ROARABIC || !n || format==ROARABICALPHAUC || 
    format==ROARABICALPHALC)
 {
  sprintf(string,"%d",n);
  *len=strlen(string);
 }
 else
 if(format==ROALPHALC || format==ROALPHAUC)
 {
  s=string+sizeof(string)-1;
  *s--=0;
  p=0;

  if(n<0)
  {
   *s++='-';
   n=-n;
  }

  while(n)
  {
   n--;   /* 1==A */

   i=n/26;
   j=n-i*26;

   if(format==ROALPHALC) *s--='a'+j;
   else                  *s--='A'+j;
   p++;

   n=i;
  }

  *len=p;
  *result=s+1;
 }
 else
 if(format==ROLOWER || format==ROUPPER)
 {
  p=7;

  if(n<0)
  {
   *s++='-';
   n=-n;
  }

  while(p--)
  {
   i=n/rvals[p];
   while(i--) *s++=cvals[format][p];
   n=n % rvals[p];

   if(!n) break;

   if(p>0)
   {
    for(j=p-1;j>=0;j--)
    {
     if(((rvals[p]-rvals[j])<=n) && ((rvals[p]-rvals[j])>rvals[j]))
     {
      *s++=cvals[format][j];
      *s++=cvals[format][p];
      n-=(rvals[p]-rvals[j]);
      break;
     }
    }
   }
  }
  *s=0;
  *len=s-string;
 }
}




/* to roman string */

int itors(int fp)
{
 char * p;
 int    len;

 roman(stack[fp],ROUPPER,0,&p,&len);
 return(createstring(p));
}


