/*->h.colour */


#define WIMPTRANS 255

#define WIMPLBLUE 15
#define WIMPORANGE 14
#define WIMPRED   11
#define WIMPGREEN 10
#define WIMPLYELLOW 12
#define WIMPDGREEN 13
#define WIMPYELLOW 9
#define WIMPDBLUE 8
#define WIMPBLACK 7
#define WIMPGREY1 1
#define WIMPGREY2 2
#define WIMPGREY3 3
#define WIMPGREY4 4
#define WIMPGREY5 5
#define WIMPGREY6 6
#define WIMPWHITE 0

#define PALWHITE (0xFFFFFF00)
#define PALBLACK (0x0)
#define PALTRANSPARENT (0xFFFFFFFF)


#define MAXSYSCOLOUR   29
extern int winsyscolour[];

#define CCMASK        255
#define CCNULL        0
#define CCRGB         1
#define CCWIMPBASE    2
#define CCSYSBASE     18
#define CCTRANSPARENT 255





typedef struct vdustr
{
 int deltax;
 int deltay;
 int maskx;
 int masky;
 int screenx;
 int screeny;
 int lndeltax;
 int lndeltay;
 int ncolours;
 int gcharsizex;
 int gcharsizey;
 int gcharspacex;
 int gcharspacey;
 int ln2bpp;
 int mode;
 int xdpi;
 int ydpi;
 int xpix;
 int ypix;
 int bpp;
 int extrax;
 int extray;
 int caps;
 int palettesupport;
 int sizepalette;          // size of palette if there is a palette
 int reservedcolours;      // number of reserved colours in the palette, if there is a palette
 int numcolours;           // entries in device colour table
 int tbpp;

 wimp_palettestr vdupal;
 int             wimpcolnos[16];

} vdustr;


extern vdustr cvdu;



extern int hscrlbar;
extern int vscrlbar;





extern vdustr   * getcvdu(void);
extern void       getcurdeltas(int * dx,int * dy);
extern void       vdumodevars(void);
extern void       vdupalvars(void);
extern void       vdupalvars2(vdustr * vdu);
extern void       vdumodevars2(vdustr * vdu);
extern void       vdumodefinit(void);



extern os_error * setgcolactionreturn(int pal,int action,int * value);
extern os_error * setgcolaction(int pal,int action);
extern os_error * setgcol(int pal);

extern os_error * seteorcol(int back,int front);
extern os_error * seteorcolpal(int back,int front);

extern int getcolnumber(int pal);
extern int getgcolnumber(int pal);
extern os_error * setoppgcol(int pal);




extern os_error * getdeltas(int mode,int * dx,int * dy);
extern os_error * getbpp(int mode,int * bpp,int * bitmask);

extern os_error * getspriteinfo(newsprite_header * sph,int * xdpi,int * ydpi,int * bpp);

extern os_error * getspritesize(newsprite_header * sph,int * xpix,int * ypix,int * bpp);


extern os_error * wimp_setoscolour(int colour);

